#ifndef BS_ACCUMULATOR_H
#define BS_ACCUMULATOR_H

#include <QGraphicsView>
#include "bsaccumulatoritem.h"


class BSAccumulatorView : public QGraphicsView
{

public:

  /**
   * \brief Creates an accumulator analyzer.
   */
  BSAccumulatorView (BSDetector *sd);

  /**
   * \brief Deletes the accumulator analyzer.
   */
  ~BSAccumulatorView ();

  /**
   * \brief Redraws the accumulator analyzer.
   */
  void paint (QPainter *painter,
              const QStyleOptionGraphicsItem *option, QWidget *widget);

  /**
   * \brief Processes key pressed events.
   */
  bool processKeyEvent (QKeyEvent *event);

protected:

private:
  static const int CELL_SIZE;
  BSAccumulatorItem *grid;

};

#endif
